ga3w20/src/main/java/com/ga3w20/beans/SurveyBean.java
package com.ga3w20.beans;

import com.ga3w20.controllers.AnswersJpaController;
import com.ga3w20.controllers.QuestionsJpaController;
import com.ga3w20.entities.Answers;
import com.ga3w20.entities.Questions;
import com.ga3w20.exceptions.RollbackFailureException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import javax.annotation.PostConstruct;
import javax.enterprise.context.SessionScoped;
import javax.inject.Inject;
import javax.inject.Named;
import org.primefaces.model.charts.ChartData;
import org.primefaces.model.charts.axes.cartesian.CartesianScales;
import org.primefaces.model.charts.axes.cartesian.linear.CartesianLinearAxes;
import org.primefaces.model.charts.axes.cartesian.linear.CartesianLinearTicks;
import org.primefaces.model.charts.bar.BarChartOptions;
import org.primefaces.model.charts.hbar.HorizontalBarChartDataSet;
import org.primefaces.model.charts.hbar.HorizontalBarChartModel;
import org.primefaces.model.charts.optionconfig.title.Title;
import org.slf4j.LoggerFactory;

/**
 * This class will get a question from the db and will display the answers for the question after the question has been answered
 * 
 * @author Michael Mishin 1612993
 */
@Named
@SessionScoped
public class SurveyBean implements Serializable {
    private final static org.slf4j.Logger LOG = LoggerFactory.getLogger(SurveyBackBean.class);
    
    private boolean renderSurvey = true;
    private boolean renderResult = false;
    
    private Questions currentQuestion;
    private Integer resultId;
    
    private HorizontalBarChartModel hbarModel;
    private HorizontalBarChartDataSet hbarDataSet;
    private ChartData graphData;
    
    @Inject
    private AnswersJpaController answersController;
    @Inject
    private QuestionsJpaController questionsController;
    
    /**
     * post construct constructor.
     * 
     * Every session chooses a random question.
     * @author Michael Mishin 1612993
     */
    @PostConstruct
    public void init()
    {
        currentQuestion = questionsController.getActiveQuestion();
        
        // creating the graph options and look
        hbarModel = new HorizontalBarChartModel();
        graphData = new ChartData();
        hbarDataSet = new HorizontalBarChartDataSet();
        
        hbarDataSet.setLabel(currentQuestion.getQuestionText());

        // colors
        List<String> bgColor = new ArrayList<>();
        bgColor.add("rgba(255, 159, 64, 0.2)");
        bgColor.add("rgba(255, 205, 86, 0.2)");
        bgColor.add("rgba(54, 162, 235, 0.2)");
        bgColor.add("rgba(153, 102, 255, 0.2)");
        hbarDataSet.setBackgroundColor(bgColor);

        List<String> borderColor = new ArrayList<>();
        borderColor.add("rgb(255, 159, 64)");
        borderColor.add("rgb(255, 205, 86)");
        borderColor.add("rgb(54, 162, 235)");
        borderColor.add("rgb(153, 102, 255)");
        hbarDataSet.setBorderColor(borderColor);
        hbarDataSet.setBorderWidth(1);

        graphData.addChartDataSet(hbarDataSet);

        //Options
        BarChartOptions options = new BarChartOptions();
        CartesianScales cScales = new CartesianScales();
        CartesianLinearAxes linearAxes = new CartesianLinearAxes();
        CartesianLinearTicks ticks = new CartesianLinearTicks();
        ticks.setBeginAtZero(true);
        linearAxes.setTicks(ticks);
        cScales.addXAxesData(linearAxes);
        options.setScales(cScales);

        Title title = new Title();
        title.setDisplay(false);
        title.setText(currentQuestion.getQuestionText());
        options.setTitle(title);

        hbarModel.setOptions(options);
        LOG.debug("graph options created");
    }
    
    /**
     * This method will save the id for the selected answer.
     * Will increment the value of the answer in the DB
     * 
     * @param resultId The id of the answer to increment
     * @author Michael Mishin 1612993
     */
    public void setResultId(Integer resultId)
    {
        //updates the DB with the answer
        Answers chosenAnswer = answersController.findAnswers(resultId);
        chosenAnswer.setChosenTimes(chosenAnswer.getChosenTimes()+1);
        
        try {
            answersController.edit(chosenAnswer);
            LOG.debug("answer was updated successfuly");
        } catch (RollbackFailureException ex) {
            LOG.error("rollaback", ex);
        } catch (Exception ex) {
            LOG.error("Exception", ex);
        }
        
        this.resultId = resultId; // saves the last answer Id
    }
    
    /**
     * This method will get the chosen answer id.
     * 
     * @return the id of the answer
     * @author Michael Mishin 1612993
     */
    public Integer getResultId()
    {
        
        return resultId;
    }
    
    /**
     * This method will get the chosen answer's text.
     * 
     * @return the text for the answer
     * @author Michael Mishin 1612993
     */
    public String getResultText()
    {
        LOG.debug("getting the answer text");
        return answersController.findAnswers(resultId).getAnswerText();
    }
    
    /**
     * This method will get the question text for the randomly chosen question.
     * 
     * @return The question text
     * @author Michael Mishin 1612993
     */
    public String getQuestionText()
    {
        LOG.debug("getting the question text");
        return currentQuestion.getQuestionText();
    }
    
    /**
     * This method will get all the answers for the current question.
     * 
     * @return 
     */
    public List<Answers> getAnswers()
    {
        LOG.debug("getting the Answers list for the current question");
        currentQuestion = questionsController.getActiveQuestion(); // gets the updated object
        return currentQuestion.getAnswersList();
    }
    
    /**
     * This method will check if the person has answered the survey.
     * If the person has answered the question, then the survey should not be rendered.
     * 
     * @return If the survey should be rendered
     * @author Michael Mishin 1612993
     */
    public boolean getRenderSurvey()
    {
        return renderSurvey;
    }
    
    /**
     * This method will check if the person has answered the survey.
     * If the person has answered the survey, then the result graph should be rendered.
     * 
     * @return If the result graph should be rendered.
     * @author Michael Mishin 1612993
     */
    public boolean getRenderResult()
    {
        return renderResult;
    }
    
    /**
     * This method will return the graph model needed for PrimeFaces component to function.
     * 
     * @return The horizontal bar component for PrimeFaces
     * @author Michael Mishin 1612993
     */
    public HorizontalBarChartModel getHbarModel() {
        return hbarModel;
    }
    
    /**
     * This method will update rendering and graph data when the person submits an answer
     * 
     * @author Michael Mishin 1612993
     */
    public void updateSurvey()
    {
        switchRendering();
        updateGraphData();
    }
    
    /**
     * This method will switch between the survey rendering and result rendering
     * 
     * @author Michael Mishin 1612993
     */
    private void switchRendering()
    {
        //updates the rendering (shows answers, removes the radio buttons
        this.renderResult = true;
        this.renderSurvey = false;
    }
    
    /**
     * This method will update the data required for the graph to generate properly.
     * 
     * @author Michael Mishin 1612993
     */
    private void updateGraphData()
    {
        List<Number> values = new ArrayList<>();
        List<String> labels = new ArrayList<>();
        
        getAnswers().forEach(answer ->{
            values.add(answer.getChosenTimes());
            labels.add(answer.getAnswerText());
        });
        
        hbarDataSet.setData(values);
        graphData.setLabels(labels);
        hbarModel.setData(graphData);
    }
}

ga3w20/src/main/webapp/WEB-INF/sections/footer.xhtml
<ui:composition
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
    xmlns:h="http://xmlns.jcp.org/jsf/html"
    xmlns:b="http://bootsfaces.net/ui"
    xmlns:jsf="http://xmlns.jcp.org/jsf"
    xmlns:a="http://xmlns.jcp.org/jsf/passthrough"
    xmlns:f="http://xmlns.jcp.org/jsf/core"
    xmlns:p="http://primefaces.org/ui">

    <h:graphicImage library="images" name="footer-shape.png" class="img-responsive imageShape" />
    <div class="footerSection">
        <b:container fluid="true">
            <div class="row">
                <div class="col-md-4 sectionSeparator">
                    <h2>#{msgs.aboutUs}</h2>
                    <p>#{msgs.helpDescr}</p>
                    <p>#{msgs.aboutUsInfo}</p>
                </div>

                <div class="col-md-4 sectionSeparator">
                    <h2>#{msgs.quickLinks}</h2>
                    <h:form>
                        <div class="input-group">
                            <h:inputText  styleClass="form-control" id="searchTerm" a:placeholder="#{msgs.searchBooks}"  value="#{theBooks.searchTerm}" rendered="#{theReviews.rating eq '' or theReviews.rating eq null}"/>
                            <div class="input-group-btn">
                                <button class="btn btn-default"  type="submit" value="submit" jsf:action="#{theBooks.processSeacrh(user.userId)}" jsf:rendered="#{theReviews.rating eq '' or theReviews.rating eq null}">
                                <i class="glyphicon glyphicon-search"></i>
                              </button>
                            </div>
                        </div>
                    </h:form>
                    <ul>
                        <li><a href="/ga3w20/help.xhtml">#{msgs.help}</a></li>
                    </ul>
                </div>

                <!-- Survey Section -->
                <h:form id="surveyForm">
                    <div class="col-md-4 sectionSeparator">
                        <div class="SurveyContainer">
                            <h2>#{msgs.surveyQuestion} #{surveyBean.questionText}</h2>
                            
                            <!-- survey options -->
                            <h:selectOneRadio rendered="#{surveyBean.renderSurvey}" id="nameId" value="#{surveyBean.resultId}">
                                <f:selectItems value="#{surveyBean.answers}" var="answer" itemValue="#{answer.id}" itemLabel="#{answer.answerText}"/>
                            </h:selectOneRadio>

                            <!-- Submit survey -->
                            <h:commandLink rendered="#{surveyBean.renderSurvey}" styleClass="answerButton">
                                <span>Submit</span>
                                <f:ajax execute="nameId" render="surveyForm" listener="#{surveyBean.updateSurvey()}" />
                            </h:commandLink>
                        </div>

                        <h:panelGroup id ="outputMessage" layout="block">
                            <h:panelGroup rendered="#{surveyBean.renderResult}" layout="block">
                                <p>#{msgs.youChose} #{surveyBean.resultText}</p>
                                <p:barChart model="#{surveyBean.hbarModel}" />
                            </h:panelGroup>
                        </h:panelGroup>
                    </div>
                </h:form>
            </div>
        </b:container>

        <!-- copyright section -->
        <div class="copyrightSection">
            <p class="text-center">420-625-DW Internet Application Project</p>
            <p class="text-center">TomNookBooks #{msgs.madeWith} &#10084;&#65039; #{msgs.by} Michael Mishin, Alexander Berestetskyy, Hadil A. Elhashani, Franco G. Moro #{msgs.et} Yongchao Li</p>
        </div>

    </div>

</ui:composition>

ga3w20/src/main/webapp/WEB-INF/sections/menu.xhtml
<ui:composition
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
    xmlns:h="http://xmlns.jcp.org/jsf/html"
    xmlns:b="http://bootsfaces.net/ui" 
    xmlns:p="http://primefaces.org/ui"
    xmlns:jsf="http://xmlns.jcp.org/jsf"
    xmlns:a="http://xmlns.jcp.org/jsf/passthrough"
    xmlns:f="http://xmlns.jcp.org/jsf/core">

    <nav class="navbar navbar-default noMargin">
        <div class="container-fluid">
          <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#myNavbar">
              <span class="icon-bar"></span>
              <span class="icon-bar"></span>
              <span class="icon-bar"></span>                        
            </button>
            <a class="navbar-brand logoContainer" href="/ga3w20/index.xhtml" jsf:rendered="#{theReviews.rating eq '' or theReviews.rating eq null}"><h:graphicImage library="images" name="logo.png" class="img img-fluid logoSize" rendered="#{theReviews.rating eq '' or theReviews.rating eq null}"/></a>
          </div>
          <div class="collapse navbar-collapse" id="myNavbar">
            <ul class="nav navbar-nav">
               <li jsf:rendered="#{theReviews.rating eq '' or theReviews.rating eq null}"><a href="/ga3w20/index.xhtml">#{msgs.home}</a></li>
              <li id="helpBtn" jsf:rendered="#{theReviews.rating eq '' or theReviews.rating eq null}"><a href="/ga3w20/help.xhtml">#{msgs.help}</a></li>
              <li id="adminBtn" jsf:rendered="#{user.manager}"><a href="/ga3w20/management/management.xhtml">#{msgs.administration}</a></li>
              <li id="downloadPageBtn" jsf:rendered="#{user.logged}"><a href="/ga3w20/downloads.xhtml">#{msgs.downloadsPage}</a></li>
            </ul>
              
            <!-- search form -->    
            <h:form class="navbar-form navbar-left">
              <div class="input-group">
                  <h:inputText  styleClass="form-control" id="searchTerm" a:placeholder="#{msgs.searchBooks}"  value="#{theBooks.searchTerm}" rendered="#{theReviews.rating eq '' or theReviews.rating eq null}"/>
                <div class="input-group-btn">
                    <button id="searchSelectBy" class="btn btn-default"  type="submit" value="submit" jsf:action="#{theBooks.processSeacrh(user.userId)}" jsf:rendered="#{theReviews.rating eq '' or theReviews.rating eq null}">
                    <i class="glyphicon glyphicon-search"></i>
                  </button>
                </div>
                    <h:selectOneMenu styleClass="selectByMenu" value="#{theBooks.selectBy}" rendered="#{theReviews.rating eq '' or theReviews.rating eq null}">
                        <f:selectItem itemLabel="#{msgs.by} Book Title" itemValue="bookTitle" noSelectionOption="true"/>
                        <f:selectItem itemLabel="#{msgs.by} Author Name" itemValue="authorName" />
                        <f:selectItem itemLabel="#{msgs.by} Publisher" itemValue="publisher" />
                        <f:selectItem itemLabel="#{msgs.by} Isbn" itemValue="isbn" />
                        <p:ajax event="change"/>
                    </h:selectOneMenu>
              </div>
            </h:form>
            
            <!--Search by Genre(with top 5 sellers)-->
            <h:form class="navbar-form navbar-left">
                <div class="input-group">
                    <p class="pSelectByGenre" jsf:rendered="#{theReviews.rating eq '' or theReviews.rating eq null}">#{msgs.searchGenre}:</p>
                        <h:selectOneMenu styleClass="selectByGenre" value="#{theBooks.selectByGenre}" rendered="#{theReviews.rating eq '' or theReviews.rating eq null}">
                            <f:selectItems value="#{theBooks.genres}" var="genre" itemValue="#{genre}" itemLabel="#{genre}"/>
                            <p:ajax event="change"/>
                        </h:selectOneMenu>
                    <div class="input-group-btn" style="float:left">
                        <button id="searchBrowseByGenre" class="btn btn-default" type="submit" value="submit" jsf:action="#{theBooks.processSeacrhByGenre}" jsf:rendered="#{theReviews.rating eq '' or theReviews.rating eq null}">
                            <i class="glyphicon glyphicon-search"></i>
                        </button>
                    </div>
                </div>
            </h:form>
            
            <ul class="nav navbar-nav navbar-right">
                <!--The language change -->
                <li class="dropdown">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">#{localeBean.language} <span class="caret"></span></a>
                    <ul class="dropdown-menu">
                        <li><h:form class="text-center"><h:commandLink value=" EN" action="#{localeBean.setLanguage('en', 'CA')}"/></h:form></li>
                        <li><h:form class="text-center"><h:commandLink value=" FR" action="#{localeBean.setLanguage('fr', 'CA')}"/></h:form></li>
                    </ul>
                </li>
                
                <li><h:outputLink id="signupBtn" value="signup.xhtml" rendered="#{!user.logged}" ><span class="glyphicon glyphicon-user"> Sign-up</span></h:outputLink></li>
                <li><h:outputLink value="signout.xhtml" rendered="#{user.logged}" > <span class="glyphicon glyphicon-log-out"> Log-Out</span></h:outputLink></li>
                <li><h:outputLink id="loginBtn" value="signin.xhtml" rendered="#{!user.logged}"> <span class="glyphicon glyphicon-log-in"> Login</span></h:outputLink> </li>
                <!--<li><a href="signin.xhtml"><span class="glyphicon glyphicon-log-in"></span> Login</a></li>-->
                
                <li jsf:rendered="#{theReviews.rating eq '' or theReviews.rating eq null}"><a href="/ga3w20/shoppingCart.xhtml"><span class="glyphicon glyphicon-shopping-cart" jsf:rendered="#{theReviews.rating eq '' or theReviews.rating eq null}"></span><h:outputText rendered="#{!shoppingCartBean.isEmpty()}" value=" #{shoppingCartBean.shoppingListLength}"/></a></li>
<!--                <li><a href="/ga3w20/shoppingCart.xhtml"><span class="glyphicon glyphicon-shopping-cart" jsf:rendered="#/{theReviews.rating eq '' or theReviews.rating eq null}"></span></a></li>-->
            </ul>
          </div>
        </div>
    </nav>
    
</ui:composition>